The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
#include<stdio.h>
#include<string.h>
#include<queue>
using namespace std;
bool vis[10][10][10][10];
int A,B,C,D;
int isprime(int a,int b,int c,int d)
{
int i;
int t;
t=a*1000+b*100+c*10+d;
for(i=2;i*i<=t;i++)
{
if(t%i==0)
return 0;
}
return 1;
}
struct node{
int a;
int b;
int c;
int d;
int step;
}p,q,que[12345];
void bfs(int a,int b,int c,int d)
{
int front=0,rear=0;
p.step=0;
vis[a][b][c][d]=1;
que[rear++]=p;
// printf("%d\n",que[0].step);
while(front<rear)
{
p=que[front++];
if(p.a==A&&p.b==B&&p.c==C&&p.d==D)
{
printf("%d\n",p.step);
return;
}
for(int i=1;i<=9;i++)
{
q=p;
q.a=i;
if(isprime(q.a,q.b,q.c,q.d)&&!vis[q.a][q.b][q.c][q.d])
{q.step=p.step+1;
vis[q.a][q.b][q.c][q.d]=1;
que[rear++]=q;}
}
for(int i=0;i<=9;i++)
{
q=p;
q.b=i;
if(isprime(q.a,q.b,q.c,q.d)&&!vis[q.a][q.b][q.c][q.d])
{ q.step=p.step+1;
vis[q.a][q.b][q.c][q.d]=1;
que[rear++]=q;
}
}
for(int i=0;i<=9;i++)
{
q=p;
q.c=i;
if(isprime(q.a,q.b,q.c,q.d)&&!vis[q.a][q.b][q.c][q.d])
{ q.step=p.step+1;
vis[q.a][q.b][q.c][q.d]=1;
que[rear++]=q;
}
}
for(int i=0;i<=9;i++)
{
q=p;
q.d=i;
if(isprime(q.a,q.b,q.c,q.d)&&!vis[q.a][q.b][q.c][q.d])
{ q.step=p.step+1;
vis[q.a][q.b][q.c][q.d]=1;
que[rear++]=q;
}
}
}
printf("Impossible\n");
}
int main()
{
int t;
scanf("%d",&t);
while(t--)
{
memset(vis,0,sizeof(vis));
int a,b;
scanf("%d%d",&a,&b);
p.a=a/1000;
A=b/1000;
a=a%1000;
p.b=a/100;
b=b%1000;
B=b/100;
b=b%100;
a=a%100;
p.c=a/10;
C=b/10;
b=b%10;
p.d=a%10;
D=b;
bfs(p.a,p.b,p.c,p.d);
}
}